	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;;;                                                    ;;;
	;;;  L       i    t                  OOO         t     ;;;
	;;;  L            t                 O   O        t     ;;;
	;;;  L      ii   ttt    eee   sss   O   O u   u ttt    ;;;
	;;;  L       i    t    e   e s      O   O u   u  t     ;;;
	;;;  L       i    t    eeeee  sss   O   O u   u  t     ;;;
	;;;  L       i    t  t e         s  O   O u  uu  t  t  ;;;
	;;;  LLLLL  iii    tt   eee  ssss    OOO   uu u   tt   ;;;
	;;;                                                    ;;;
	;;;                   v1.0 by Adamman                  ;;;
	;;;                      11/27/97                      ;;;
	;;;                    For  Ash 3.0                    ;;;
	;;;                                                    ;;;
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;   Here is the source to Lites Out (otherwise known as LO).  You
; may use any routines in here as long as you give me credit :).
; I wrote this using Editpad 2.0.0 (http://www.tornado.be/~johnfg/)
; at 800x600, so most people I think will have to turn off wordwrap.
;   This file is very well commented, and I encourage you to use it
; to learn ASM ;).
;   This is my second ASM game, if you haven't already checked out
; SameGame then do so!  It rocks!
;   That's all, please enjoy the use of this sourcecode!

#include ti82.h

LITE_BOARD = TEXT_MEM			;the area you're playing on, 25 bytes
LEVEL = TEXT_MEM+25			;the current level, byte
MOVES = TEXT_MEM+26			;the max moves, byte
HELP1 = TEXT_MEM+27			;first help move, byte
HELP2 = TEXT_MEM+28			;second help move, byte
STATE = TEXT_MEM+29			;store whether you've done too many moves, byte
COUNTER = TEXT_MEM+30			;how many moves over you are, byte
HUH = TEXT_MEM+31				;do you count how many moves over?, byte
GAME_MODE = TEXT_MEM+32			;the current game mode (1,2,3), byte
MODE_SELECTOR = TEXT_MEM+33		;are we in the mode selector?, byte
SAVE_LITE_BOARD = TEXT_MEM+34		;buffer to save the lite board (BLINK), 25 bytes
SAVE_LITE_BOARD2 = TEXT_MEM+59	;second buffer, used in mode 2, 25 bytes
SAVE_MOVES = TEXT_MEM+84		;save the max moves for mode 2
ARCHIVE = TEXT_MEM+85			;archive for moves in mode 2 level generator, 15 bytes
DO_YOU_HELP = TEXT_MEM+100		;is a help allowed?, byte
BLINK_CODE = TEXT_MEM+101		;blink mode, byte
CURRENT_HELP = TEXT_MEM+102		;which help move you're on, byte
LEVEL_MAKER = TEXT_MEM+103		;are we in the level maker?, byte
END_LITES = TEXT_MEM+104		;are we at the end of the startup sequence?, byte

LEVELSIZE = 9				;size of the level (it changes)

;#DEFINE SOUND

.org START_ADDR

#IFNDEF SOUND
.db "Lites Out v1.0 by Adamman", 0
#ELSE
.db "Lites Out v1.0 with sound", 0
#ENDIF

	ld a, $8C				;change ROM page to page 4
	out (2), a				;required by FIND_PIXEL

	ld a, r				;get randseed from r register
	ld d, a				;load higher byte
	srl a					;shift right
	ld e, a				;load lower byte
	ld hl, (RANDSEED)			;load randseed
	add hl, de				;add to r randseed
	ld (RANDSEED), hl			;reload randseed

#IFDEF SOUND
	ld hl, $0002			;cursor pos 0,2
	ld ($800C), hl			;load it
	set 3, (iy+$05)			;reversed text
	ld hl, HEADPHONE_TEXT		;display 'insert headphone' thing
	push de				;save de
	ROM_CALL(D_ZT_STR)		;display string
	pop de				;restore de
	res 3, (iy+$05)			;normal text
loop:
	call GET_KEY			;wait for user to insert headphones
	inc de				;keep randomizing the randseed
	or a					;cp 0
	jr z, loop				;keep looping

	ld hl, (RANDSEED)			;load the randseed
	add hl, de				;add it to other randseed
	ld (RANDSEED), hl			;reload randseed
#ENDIF
	ld hl, (MAX_LEVEL)		;get offset of max level
	ld (CURRENT_LEVEL), hl		;load it into current level

	call STARTUP			;startup sequence
START:
	ld (ix), 0				;erase last lite
	call CHANGE_ADJ			;make a cross in the middle
	call REFRESH_LITES		;refresh the lite board into the graph mem
	ROM_CALL(DISP_GRAPH)		;copy the graph mem to the lcd
#IFDEF SOUND
	call BEEPER				;make beeping noise
#ENDIF
	call BUFCLEAR2			;clear the lite board
	ld de, (RANDSEED)			;get full randseed
	ld a, 1				;mode 1
	ld (GAME_MODE), a			;load it
	ld (LITE_BOARD), a		;also the first lite on the lite board

key_loop1:
	call GET_KEY			;get keystroke
	inc de				;keep track of partial randseed
	cp 15					;clear
	ret z					;go back
	cp 55					;mode
	jp z, MODE_LOOPER			;select mode
	push af				;save af
	ld a, $BF				;the mask for Y=+GRAPH detection
	out (1), a				;mask the port
	in a, (1)				;get input from the port
	cp $EE				;is Y= and GRAPH held down?
	jr nz, NO_RESET			;no, dont reset to level one
	ld hl, LEVEL1			;yes, load hl with level one's address
	ld (MAX_LEVEL), hl		;load hl into the max level offset
	ld (CURRENT_LEVEL), hl		;and the current level
	ld hl, $0003			;cursor pos 0,3
	ld ($800C), hl			;load it
	set 3, (iy+$05)			;reversed text
	ld hl, RESET_TEXT			;ld the string
	push de				;save de
	ROM_CALL(D_ZT_STR)		;display the reset game text
	pop de				;restore de
	res 3, (iy+$05)			;normal text
	ld bc, 500				;loop 500d times
RESET_LOOP:
	halt					;wait for int
	dec bc				;dec the counter
	ld a, b				;necessary for knowing if a 16-bit reg is zero
	or c					;|
	jr nz, RESET_LOOP			;keep looping
	ROM_CALL(DISP_GRAPH)		;copy the graph mem to the lcd (erase text)
NO_RESET:
	pop af				;restore af
	cp 56					;delete
	jr nz, key_loop1			;delete = start
	ld hl, (RANDSEED)			;get full randseed
	add hl, de				;add it with partial randseed
	ld (RANDSEED), hl			;load full randseed back

GAME1_START:
	call BLINK_LEVEL			;blink what the current level is
GAME1_START_AGAIN:
	xor a					;ld a, 0
	ld (COUNTER), a			;init vars
	ld (HUH), a				;|
	inc a					;now a = 1
	ld (CURRENT_HELP), a		;see above for var definitions
	ld (DO_YOU_HELP), a		;|
	ld (MODE_SELECTOR), a		;|
	ld (STATE), a			;|
	ld (GAME_MODE), a			;|
	ld hl, (CURRENT_LEVEL)		;ld hl with the address of the level to decompress
	call DECOMPRESS			;decompress the level pointed to by hl to the lite board
GAME_START:
	ld de, $8A3D			;middle of the screen
	ld ix, $809B			;|

GAME1_LOOP:
	call REFRESH_LITES		;refresh the lite board to the graph mem
	call CURSOR				;cursor routine
	xor a					;ld a, 0
	ld (DO_YOU_HELP), a		;dont help if a move has been made
	ld hl, MOVES			;are you over the moves limit?
	dec (hl)				;dec # of moves
	ld a, (hl)				;get # of moves
	cp $FF				;have you done too many?
	jr nz, GO_ON			;no
	ld a, 1				;start counting extra moves
	ld (HUH), a				;|
GO_ON:
	ld a, (HUH)				;indicator for counting extra moves
	or a					;cp 0
	jr z, GO_ON2			;nope, go on again
	ld hl, COUNTER			;ld counter offset
	inc (hl)				;inc the counter
GO_ON2:
	ld a, (COUNTER)			;get current count
	cp 11					;have you gone over 10?
	jr c, GO_ON3			;no, good job
	xor a					;ld a, 0
	ld (STATE), a			;no pass from this level
GO_ON3:
#IFDEF SOUND
	push de				;save de from the evil beeper!
	call BEEPER2			;2nd beeper routine
	pop de				;all better!
#ENDIF
	call CHANGE_ADJ			;change all adjacent lites
	call CHECK_CLEARED		;have you turned the lites out?
	jr GAME1_LOOP			;keep on loopin'

GAME2_START:
	call GENERATE_LEVEL		;generate random level
	ld hl, LITE_BOARD			;save the lite board from annihilation!
	ld de, SAVE_LITE_BOARD2		;so when you restart
	ld bc, 25				;it is the same puzzle
	ldir					;not a new random one
	ld a, (MOVES)			;also save the moves
	ld (SAVE_MOVES), a		;|
GAME2_START_AGAIN:
	call BLINK_LEVEL			;blink the number of the current level on the lite board
GAME2_START_AGAIN_AGAIN:
	ld de, LITE_BOARD			;restore the lite board
	ld hl, SAVE_LITE_BOARD2		;|
	ld bc, 25				;|
	ldir					;|
	ld a, (SAVE_MOVES)		;restore moves
	ld (MOVES), a			;|
	xor a					;ld a, 0
	ld (COUNTER), a			;init vars
	ld (HUH), a				;|
	inc a					;now a = 1
	ld (CURRENT_HELP), a		;init more vars
	ld (DO_YOU_HELP), a		;|
	ld (MODE_SELECTOR), a		;|
	ld (STATE), a			;|
	inc a					;now a = 2
	ld (GAME_MODE), a			;mode 2 - random puzzles

	jp GAME_START			;looping procedure is the same for both modes

GAME3_START:
	call MAKE_LEVEL			;get input for user-defined level
	ld hl, LITE_BOARD			;save lite board - see mode 2 for comments
	ld de, SAVE_LITE_BOARD2		;|
	ld bc, 25				;|
	ldir					;|
GAME3_START_AGAIN:
	ld de, LITE_BOARD			;restore lite board
	ld hl, SAVE_LITE_BOARD2		;|
	ld bc, 25				;|
	ldir					;|
	xor a					;ld a, 0
	ld (COUNTER), a			;init vars
	ld (HUH), a				;|
	ld (DO_YOU_HELP), a		;|
	inc a					;now a = 2
	ld (MODE_SELECTOR), a		;init vars
	ld (STATE), a			;|
	inc a					;now a = 2
	inc a					;now a = 3
	ld (GAME_MODE), a			;mode 3 - user-defined puzzles
	ld de, $8A3D			;middle of the screen
	ld ix, $809B			;|
GAME3_LOOP:
	call REFRESH_LITES		;refresh the lite board to the graph mem
	call CURSOR				;cursor routine
#IFDEF SOUND
	push de				;save de from the evil beeper!
	call BEEPER2			;beep #2
	pop de				;restore de
#ENDIF
	call CHANGE_ADJ			;change all adjacent lites
	call CHECK_CLEARED		;have you turned the lites out?
	jr GAME3_LOOP			;keep looping

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                          ;;;
;;;  Allow the user to select the game mode  ;;;
;;;                                          ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MODE_SELECT:
	xor a					;ld a, 0
	ld (MODE_SELECTOR), a		;0 = in mode selector, 1 = not
	call BUFCLEAR2			;clear the lite board
	ld de, $8A3D			;middle of the screen
	ld ix, $809B			;|

	ld a, (GAME_MODE)			;current mode
	cp 3					;under mode 3?
	jr c, MODE_0			;yes, go to 'select the level'

	ld a, 1				;1 = lite on
	ld (LITE_BOARD+2), a		;load the correct position with the 1
MODE_LOOPER:
	call REFRESH_LITES		;refresh the lite board to the graph mem
	ROM_CALL(DISP_GRAPH)		;copy the graph mem to the lcd
MODE_KEYLOOP:
	call GET_KEY			;get keystroke
	cp 15					;clear
	ret z
	cp 55					;mode
	jr z, INC_MODE
	cp 56					;del
	jr nz, MODE_KEYLOOP		;keep checking for keypresses
	ld hl, (MAX_LEVEL)		;get offset for max level
	ld (CURRENT_LEVEL), hl		;load it into the current level
	ld a, (GAME_MODE)			;get current mode
	cp 1					;mode 1?
	jp z, GAME1_START			;if so, start mode 1
	cp 2					;mode 2?
	jp z, GAME2_START			;if so, start mode 2
	jp GAME3_START			;nothing is left, so go to mode 3

INC_MODE:
	ld hl, GAME_MODE			;get offset for current mode
	inc (hl)				;inc it

	call BUFCLEAR2			;clear the lite board
	ld a, (GAME_MODE)			;get current mode
	cp 4					;4 will happen when 3+1
	jr nz, NOT_MODE_ONE		;if not, check for mode 2
	ld hl, LITE_BOARD			;the first lite
	ld a, 1				;1 = the mode
	ld (GAME_MODE), a			;load that
	jr THATS_THE_STUFF2		;load lit lite
NOT_MODE_ONE:
	cp 2					;is it mode 2?
	jr nz, NOT_MODE_TWO		;nope, it must be mode 3!
	ld hl, LITE_BOARD+1		;2nd lite
	jr THATS_THE_STUFF2		;light the lite
NOT_MODE_TWO:
	ld hl, LITE_BOARD+2		;next lite :)
THATS_THE_STUFF2:
	ld (hl), 1				;light it
	jp MODE_LOOPER			;check for keypresses

MODE_0:
	push de				;save de
	call BUFCLEAR2			;clear the lite board
	call REFRESH_LITES		;refresh the lite board to the graph mem
	ROM_CALL(DISP_GRAPH)		;copy the graph mem to the lcd
	pop de				;restore de
	call CURSOR				;let you move around the cursor
	push de				;save de
	push ix				;save ix
	ld (ix), 1				;turn the lite at (ix) on
	call REFRESH_LITES		;refresh the lite board to the graph mem
	ROM_CALL(DISP_GRAPH)		;copy the graph mem to the lcd
	call CURSOR				;the cursor treatment - again
	pop hl				;ix -> hl
	push de				;save de

	ld de, -LITE_BOARD		;add negative #
	add hl, de				;same as subtracting (now ix is converted to level #)
	ld b, l				;load it into b
	ld c, l				;and c!
	ld hl, LEVEL1			;offset of level 1
	ld de, LEVELSIZE			;de, to be added to hl
	ld a, c				;get level #
	or a					;cp 0
	jr z, LOOPDONE			;if it's 0, don't loop
MODE_0_LEVEL_LOOP:
	add hl, de				;each time added, a level is gained
	djnz MODE_0_LEVEL_LOOP		;loop as many times as needed
LOOPDONE:
	ld (CURRENT_LEVEL), hl		;load that into the current level

	ld hl, (MAX_LEVEL)		;get offset of max level
	ld de, 5				;add it with
	add hl, de				;5 to get the level #
	ld a, c				;ld the old level #back
	cp (hl)				;compare the two
	jr nc, GO_BACK			;go back; level too high
	jr DONT_GO_BACK			;don't go back, level is fine
GO_BACK:
	pop de				;restore de
	pop hl				;restore hl
	jr MODE_0				;go back to the beginning

DONT_GO_BACK:
	pop de				;restore de
	pop hl				;restore hl
	call CP_HL_DE			;compare the two keypresses
	jr nz, MODE_0			;if not the same, go back
	push de				;save de
	ld hl, (MAX_LEVEL)		;get offset of max level
	ld de, LEVEL26			;get offset of level 26
	call CP_HL_DE			;compare them
	jr nc, OVER_25			;it's over 25, so go to the right level!
	pop de				;restore de
	ld a, (GAME_MODE)			;get current game mode
	cp 1					;mode 1?
	jp z, GAME1_START			;yep, start there
	jp GAME2_START			;mode 2 is all that's left (no level select in mode 3)

OVER_25:
	ld a, 25				;you have to add 25 to what you got before 
	add a, c				;get level #
	ld c, a				;and load it back
	ld hl, (MAX_LEVEL)		;get offset of max level
	ld de, 5				;add it with five to get...
	add hl, de				;current max level #
	cp (hl)				;a still holds the level #...
	pop de				;restore de
	jr nc, MODE_0			;go back if level is too big
	ld hl, (CURRENT_LEVEL)		;get offset of current level (save of offset already gotten)
	ld bc, 25*LEVELSIZE		;multiply by the level size to get the corrent offset
	add hl, bc				;add the offsets
	ld (CURRENT_LEVEL), hl		;and load it back
	ld a, (GAME_MODE)			;get current mode
	cp 1					;mode 1?
	jp z, GAME1_START			;yeah, go there
	jp GAME2_START			;mode 2 is all that's left!

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                             ;;;
;;;  End of game mode selector  ;;;
;;;                             ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                      ;;;
;;;  Generate a random level for mode 2  ;;;
;;;                                      ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GENERATE_LEVEL:
	call BUFCLEAR2			;clear the lite board
	call BUFCLEAR3			;clear the archive of moves
	ld hl, (CURRENT_LEVEL)		;get offset for current level
	ld bc, 6				;+6 = max moves
	add hl, bc				;add 'em
	ld b, (hl)				;ld max moves into b counter
	ld a, b				;and into a, for MOVES
	ld (MOVES), a			;load data into text mem
	ld hl, ARCHIVE			;move archive
RANDOM_LEVEL_LOOP:
	push bc				;save bc
	ld ix, LITE_BOARD			;start at the lite board beginning
	call RANDOM				;get random # in a
	ld d, 0				;ld de, a
	ld e, a				;|
	call CHECK_EQUAL			;make sure the calc doesnt hit the same place twice
	jr nz, NOT_THE_SAME		;not the same - move on
	pop bc				;dont crash the stack!
	jr RANDOM_LEVEL_LOOP		;rerandom
NOT_THE_SAME:
	ld (hl), a				;ld random #
	inc hl				;next byte in archive
	add ix, de				;get offset for lite on the lite board
	push hl				;save hl
	call CHANGE_ADJ			;change all adjacent lites
	pop hl				;restore hl
	pop bc				;restore bc
	djnz RANDOM_LEVEL_LOOP		;keep randomizing
	dec hl				;last archive entry
	ld a, (hl)				;load it into a
	inc a					;inc that so it's in help format
	ld (HELP1), a			;first help
	dec hl				;previous achive thing
	ld a, (hl)				;get it
	inc a					;format it
	ld (HELP2), a			;and put it in the second help
	ret					;return

CHECK_EQUAL:
	push hl				;save hl cuz it's important
	ld hl, ARCHIVE			;offset for the archive of moves
	ld bc, 15				;15 bytes (max max moves)
	cpir					;find it
	pop hl				;restore hl
	ret

RANDOM:
	call GETRAND			;getrand is the routine in getrand.asm
	res 7, a				;bit 7 set = negetive #
RANDOM_LOOP:
	sub 25				;subtract 25 from a
	jp p, RANDOM_LOOP			;if positive, keep looping
	add a, 25				;add 25 for the last subtract, so it's 0-24
	ret

#include GETRAND.asm

RANDSEED:					;permenant randseed inside program
	.dw $0000

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                 ;;;
;;;  End of random level generator  ;;;
;;;                                 ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                 ;;;
;;;  Get input for level in Mode 3  ;;;
;;;                                 ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAKE_LEVEL:
	ld a, 1				;1 -> a
	ld (LEVEL_MAKER), a		;we are in the level maker (let cursor know that)
	call BUFCLEAR2			;clear the lite board
	ld de, $8A3D			;middle of the screen
	ld ix, $809B			;|
MAKE_LEVEL_LOOP:
	call REFRESH_LITES		;refresh the lite board to the graph mem
	call CURSOR				;cursor routine
#IFDEF SOUND
	push de				;save de
	call BEEPER2			;2nd beeper
	pop de				;restore de
#ENDIF
	ld a, (ix)				;get byte from the lite board
	xor 1					;change one byte
	ld (ix), a				;reload the byte
	jr MAKE_LEVEL_LOOP		;keep on looping

;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                      ;;;
;;;  End of level input  ;;;
;;;                      ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                      ;;;
;;;  Level Decompressor  ;;;
;;;                      ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DECOMPRESS:
	push de				;save de
	ld de, LITE_BOARD			;start at the beginning of the lite board
	ld b, 5				;five rows
DECOMPRESS_REPEATOR:
	push bc				;save bc
	ld c, %00010000			;c = mask
	ld b, 5				;five lites a row
DECOMPRESS_LOOP:
	xor a					;ld a, 0
	ld (de), a				;always assume it's zero
	ld a, (hl)				;get first byte of level (compressed)
	and c					;mask it with c
	jr z, NO_SET			;it really is zero, so don't set it
	ld a, 1				;1 = set
	ld (de), a				;set it
NO_SET:
	inc de				;next byte of lite board
	rrc c					;rotate the mask
	djnz DECOMPRESS_LOOP		;loop each part of the row
	pop bc				;restore bc
	inc hl				;next row of compressed level
	djnz DECOMPRESS_REPEATOR	;loop each row
	xor a					;ld a, 0
	ld (de), a				;assume 0
	bit 7, (hl)				;text our assumtion
	jr nz, NO_SET2			;if not, don't set it
	inc a					;0 + 1 = 1
	ld (de), a				;set lite
NO_SET2:
	inc de				;next byte of lite board (out of lite board, on level)
	inc hl				;next byte of compressed level
	ld a, (hl)				;get next byte of level
	and %00111111			;mask out two bits
	ld (de), a				;ld it into level
	inc hl				;next byte of compressed level
	inc de				;next byte (max moves)
	ld bc, 2				;load moves and helps
	ldir					;|
	pop de				;restore de
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                             ;;;
;;;  End of level decompressor  ;;;
;;;                             ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                      ;;;
;;;  Blink the level, on the Lite Board  ;;;
;;;                                      ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BLINK_LEVEL:
	call BUFCLEAR2			;clear the lite board
	ld hl, (CURRENT_LEVEL)		;get offset to current level
	ld de, 5				;add with five to get...
	add hl, de				;the levelnumber!
	ld a, (hl)				;get the levelnumber
	cp 25					;is is greater than or less that 25? (or is is 25?)
	jr c, LESS_THAN_26		;it's less that (or equal to) 25
	ld hl, LITE_BOARD+24		;bottom right corner
	ld (hl), 1				;set the lite to on
	sub 25				;make the levelnumber displayable
LESS_THAN_26:
	ld c, a				;load the levelnumber into c
	ld b, 0				;zero out b (total: ld bc, a)
	ld hl, LITE_BOARD-1		;1 less so it will display the right lite
	add hl, bc				;add offsets to get the correct lite
	ld a, 2				;blink code 2:
	ld (BLINK_CODE), a		;blink light at (hl)
	call BLINK				;blink the levelnumber graphically
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                        ;;;
;;;  End of level blinker  ;;;
;;;                        ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                            ;;;
;;;  Startup sequence routine  ;;;
;;;                            ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

STARTUP:
	xor a					;ld a, 0
	ld (END_LITES), a			;we are not on the last lites
	ld ix, LITE_BOARD			;start at the beginning of the lite board
	ld b, 5				;5 times for this loop
STARTUP_LOOP1:
	call CLEAR_LOAD_DELAY		;clear the screen, load the correct lite, and delay
	call MOVEDOWN			;move down one lite
	call DISPLAY_BEEP			;display the graph mem and beep (if applicable)
	djnz STARTUP_LOOP1		;keep looping

	ld b, 4				;4 loops this time
	call MOVEUP				;go up one lite - else you will be at the wrong addr
	inc ix				;go right one lite
STARTUP_LOOP2:
	call CLEAR_LOAD_DELAY		;clear the screen, load the correct lite, and delay
	inc ix				;go right
	call DISPLAY_BEEP			;display, beep
	djnz STARTUP_LOOP2		;keep looping

	ld b, 4
	dec ix
	call MOVEUP
STARTUP_LOOP3:
	call CLEAR_LOAD_DELAY
	call MOVEUP
	call DISPLAY_BEEP
	djnz STARTUP_LOOP3

	ld b, 3
	call MOVEDOWN
	dec ix
STARTUP_LOOP4:
	call CLEAR_LOAD_DELAY
	dec ix
	call DISPLAY_BEEP
	djnz STARTUP_LOOP4

	ld b, 3
	inc ix
	call MOVEDOWN
STARTUP_LOOP5:
	call CLEAR_LOAD_DELAY
	call MOVEDOWN
	call DISPLAY_BEEP
	djnz STARTUP_LOOP5

	ld b, 2
	call MOVEUP
	inc ix
STARTUP_LOOP6:
	call CLEAR_LOAD_DELAY
	inc ix
	call DISPLAY_BEEP
	djnz STARTUP_LOOP6

	ld b, 2
	dec ix
	call MOVEUP
STARTUP_LOOP7:
	call CLEAR_LOAD_DELAY
	call MOVEUP
	call DISPLAY_BEEP
	djnz STARTUP_LOOP7

	call MOVEDOWN
	dec ix

	call CLEAR_LOAD_DELAY
	call MOVEDOWN
	call DISPLAY_BEEP

	call CLEAR_LOAD_DELAY
	call DISPLAY_BEEP
	ld a, 1
	ld (END_LITES), a
	call STARTUP_DELAY
	ret

CLEAR_LOAD_DELAY:
	call BUFCLEAR2
	ld (ix), 1
	call STARTUP_DELAY
	ret

DISPLAY_BEEP:
	push bc				;save bc
	call REFRESH_LITES		;refresh the lite board to the graph mem
	ROM_CALL(DISP_GRAPH)		;copy the graph mem to the lcd
#IFDEF SOUND
	call BEEPER				;beep
#ENDIF
	pop bc				;restore bc
	ret

MOVEDOWN:
	ld de, 5				;+5 =
	add ix, de				;one line down
	ret

MOVEUP:
	ld de, -5				;-5 =
	add ix, de				;one line up
	ret

STARTUP_DELAY:
#IFDEF SOUND
	ld d, 9				;less delay (sound delays it also)
#ELSE
	ld d, 15				;more delay (no sound for other delay)
#ENDIF
DELAY_LOOP:
	ld a, $FD				;mask for clear detection
	out (1), a				;mask the port
	in a, (1)				;read keypresses
	bit 6, a				;bit 6 = clear
	jr nz, DONT_RETURN		;not clear, so don't return
	inc sp				;don't return to
	inc sp				;CLEAR_LOAD_DELAY
	inc sp				;don't return to
	inc sp				;STARTUP
	ld a, (END_LITES)			;unless you were in the end lites, then return NOW
	or a					;cp 0
	ret nz				;you were on the last two lites, so go back now!
	inc sp				;don't return to
	inc sp				;wherever you came from
	ret					;return to the shell
DONT_RETURN:
	halt					;wait for int
	dec d					;dec the counter
	jr nz, DELAY_LOOP			;keep looping as necessary
	ret

#IFDEF SOUND
BEEPER:
	ld b, 5				;beep 5 times (rapidly)
BEEPER_LOOP:
	ld hl, 725				;tone
	ld de, 100				;length
	call beep				;beep!
	djnz BEEPER_LOOP			;loop until done
	ret

BEEPER2:
	ld b, 5				;beep 5 times (rapidly)
BEEPER2_LOOP:
	ld hl, 691				;tone
	ld de, 100				;length
	call beep				;beep!
	djnz BEEPER2_LOOP			;loop, young man!
	ret
#ENDIF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                           ;;;
;;;  End of startup sequence  ;;;
;;;                           ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                     ;;;
;;;  Refresh the lites to coordinate with the text mem  ;;;
;;;                                                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

REFRESH_LITES:
	push de				;save de (graph mem coords)
	push ix				;save ix (text mem coords)
	call BUFCLEAR			;clear the graph mem
	ld de, $891B			;start at $981B
	ld hl, L_SPRITE			;"L"
	call PUTPIECE			;display bold "L"
	inc de				;next offset
	call PUTPIECE			;display bold "I"
	inc de				;next offset
	call PUTPIECE			;display bold "T"
	inc de				;next offset
	call PUTPIECE			;display bold "E"
	inc de				;next offset
	call PUTPIECE			;display bold "S"
	ld de, $8980			;now we're altogether changing the offset
	call PUTPIECE			;display bold and sideways "O"
	ld de, $89E0			;next offset
	call PUTPIECE			;display bold and sideways "U"
	ld de, $8A40			;next offset
	call PUTPIECE			;display bold and sideways "T"

	ld bc, $162F			;starting offset
	ld de, $1608			;ending offset
	call DRAW_LINE			;draw the line
	ld bc, $1707			;starting offset
	ld de, $3F07			;ending offset
	call DRAW_LINE			;draw the line
	ld bc, $4016			;starting offset
	ld de, $4008			;ending offset
	call DRAW_LINE			;draw the line

	ld de, $897B			;starts at $897B in graph mem
	ld ix, LITE_BOARD			;the array is stored in the text mem
	ld c, 5				;5 rows
	ld b, 5				;5 lites per row
REFRESH_LITES_LOOP:
	ld a, (ix)				;get byte from array
	or a					;cp 0
	jr z, REFRESH_LITES_NULL	;lite is off - don't put the sprite
	ld hl, LITE_SPRITE		;load the sprite for lit light
	push bc				;bc is destroyed in put piece
	call PUTPIECE			;put the lite sprite
	pop bc				;restore it
REFRESH_LITES_NULL:
	inc ix				;next byte of the array
	inc de				;next byte in graph mem
	djnz REFRESH_LITES_LOOP		;loop collumns
	dec c					;dec row counter
	jr nz, REFRESH_LITES_NEW_ROW	;loop rows

	pop ix				;restore ix
	pop de				;restore de
	set 7, (iy+$14)			;display text to graph mem
	ld hl, $3918			;load cursor pos
	ld ($8215), hl			;load it into memory :)
	ld hl, AUTHOR			;the string for "by Adamman"
	ROM_CALL(D_ZM_STR)		;display "by Adamman"
	res 7, (iy+$14)			;write text to lcd
	ret

REFRESH_LITES_NEW_ROW:
	ld hl, 91				;91 bytes to beginning of next row
	add hl, de				;add offsets
	ex de, hl				;de = hl
	ld b, 5				;5 pieces per row
	jr REFRESH_LITES_LOOP		;loop rows, again

DRAW_LINE:					;draw a line from (b,c) to (d,e)
	ld a, b				;load starting point xcoord
	cp d					;is it the same as ending point xcoord?
	jr z, LINE_DOWN			;yes, it's a vertical line
LINE_RIGHT:
	call POINT_ON			;draw a point
	ld a, b				;load again
	inc b					;next pixel
	cp d					;has the line reached its endpoint yet?
	jr nz, LINE_RIGHT			;no, keep drawing
	ret
LINE_DOWN:
	call POINT_ON			;draw a point
	ld a, c				;load the ycoord
	dec c					;them move to the next pixel
	cp e					;compare with endpoint...
	jr nz, LINE_DOWN			;not there yet, keep going!
	ret

POINT_ON:
	push bc				;save bc
	push de				;save de
	call FIND_PIXEL			;get offset of pixel
	ld de, $88B8			;add with offset
	add hl, de				;for the graph mem
	or (hl)				;set bit
	ld (hl), a				;load back
	pop de				;restore de
	pop bc				;restore bc
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                        ;;;
;;;  End of Refresh Lites  ;;;
;;;                        ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                ;;;
;;;  Draws the cursor and lets you move it around  ;;;
;;;                                                ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CURSOR:
	ld hl, CURSOR_PIECE		;load the cursor sprite
	call PUTPIECE			;put the cursor
	ROM_CALL(DISP_GRAPH)		;copy the graph mem to the lcd

CURSOR_KEY_LOOP:
	call GET_KEY			;get immediate keystroke into a reg
	cp 4					;up arrow
	jp z, MOVE_UP
	cp 1					;down arrow
	jp z, MOVE_DOWN
	cp 3					;right arrow
	jp z, MOVE_RIGHT
	cp 2					;left arrow
	jp z, MOVE_LEFT
	cp 54					;2nd
	ret z
	cp 55					;mode
	jr nz, NO_MODE_SELECTING
	inc sp				;don't return to
	inc sp				;GAME_LOOP or GAME3_LOOP

	ld a, (MODE_SELECTOR)		;are we in here from the mode selector?
	or a					;cp 0
	jp nz, MODE_SELECT		;yes, go back where we came from!

	call BUFCLEAR2			;clear the lite board
	ld a, (GAME_MODE)			;current mode
	cp 3					;mode 3 gets us sent back!
	jp z, MODE_SELECT			;go to where ye is bound for!
	cp 1					;mode 1?
	jr nz, NOT_MODE_1			;no
	ld hl, LITE_BOARD			;turn on the lite at (lite board)
	jr THATS_THE_STUFF		;turn it on
NOT_MODE_1:
	cp 2					;mode 2?
	jr nz, NOT_MODE_2			;nope
	ld hl, LITE_BOARD+1		;this will turn the next lite over on
	jr THATS_THE_STUFF		;turn it on!
NOT_MODE_2:
	ld hl, LITE_BOARD+2		;this is redundant
THATS_THE_STUFF:
	ld (hl), 1				;1 = on :)
	jp MODE_LOOPER			;go to the mode selector loop

NO_MODE_SELECTING:
	cp 9					;enter
	ret z

	cp 32					;stat
	jp z, HELP

	cp 15					;clear
	jr z, END_GAME

	cp 56					;del
	jr nz, CURSOR_KEY_LOOP		;keep checking for keypresses
	inc sp				;don't return to
	inc sp				;GAME_LOOP or GAME3_LOOP
	ld a, (GAME_MODE)			;current mode
	cp 1					;mode 1?
	jp z, GAME1_START_AGAIN		;yep
	cp 2					;mode 2?
	jp z, GAME2_START_AGAIN_AGAIN	;yeah!
	ld a, (LEVEL_MAKER)		;are we coming from the level maker?
	or a					;cp 0
	jp z, GAME3_START_AGAIN		;no, start game 3
	xor a					;ld a, 0
	ld (LEVEL_MAKER), a		;NOT in the level maker any more
	ret

END_GAME:
	inc sp				;don't return to GAME_LOOP or GAME3_LOOP
	inc sp				;return to the shell
	ld a, (LEVEL_MAKER)		;that is...
	or a					;if you're not in
	ret z					;the level maker!
	ld a, (MODE_SELECTOR)		;or the mode selector....
	or a					;cp 0
	ret nz				;not in the mode selector!
	inc sp				;don't return to
	inc sp				;MAKE_LEVEL or MODE_SELECT
	ret

CURSOR_ERASE:
	push bc				;save bc
	push hl				;save hl
	ld hl, CURSOR_PIECE		;the sprite for the cursor
	call PUTPIECE			;erase the cursor by re-xoring it
	pop hl				;restore hl
	pop bc				;restore bc
	add ix, bc				;get new offset
	add hl, de				;update cursor position
	ex de, hl				;exchange (de = sum)
	jp CURSOR

MOVE_UP:
	ld hl, -96				;-96 = -12*8
	ld bc, -5				;to move up 8 lines
	.db $DD				;ix prefix
	ld a, l				;lower byte of ix
	cp $94				;if you're on the top row,
	jp c, CURSOR_KEY_LOOP		;don't go higher
	jr CURSOR_ERASE			;erase the cursor

MOVE_DOWN:
	ld hl, 96
	ld bc, 5				;to move down 8 lines
	.db $DD
	ld a, l				;lower byte of ix
	cp $A3				;if you're on the bottom row,
	jr c, CURSOR_ERASE		;erase the cursor
	jp CURSOR_KEY_LOOP

MOVE_RIGHT:
	.db $DD
	ld a, l				;lower byte of ix
	ld hl, RIGHT_LIMITS
	ld bc, 5				;5 bytes to check
	cpir
	jp z, CURSOR_KEY_LOOP
	ld hl, 1				;move right 1 byte
	ld bc, 1				;move right 1 byte
	jr CURSOR_ERASE			;if not on the right edge
RIGHT_LIMITS:
	.db $93, $98, $9D, $A2, $A7

MOVE_LEFT:
	.db $DD
	ld a, l				;lower byte of ix
	ld hl, LEFT_LIMITS
	ld bc, 5				;5 bytes to check
	cpir
	jp z, CURSOR_KEY_LOOP
	ld hl, -1				;move left 1 byte
	ld bc, -1				;move left 1 byte
	jr CURSOR_ERASE			;if not on the right edge
LEFT_LIMITS:
	.db $8F, $94, $99, $9E, $A3

;;;;;;;;;;;;;;;;;;;;;;;
;;;                 ;;;
;;;  End of Cursor  ;;;
;;;                 ;;;
;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                    ;;;
;;;  "Help" function"  ;;;
;;;                    ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;

HELP:
	ld a, (DO_YOU_HELP)		;set to zero if you've already moved
	or a					;cp 0
	jp z, CURSOR_KEY_LOOP		;go back to checking keys
	ld a, (CURRENT_HELP)		;get # of current help space
	cp 1					;first help space?
	jr nz, HELP_ON_2			;nope, get the second one

	ld a, (HELP1)			;get the # for the first help
	or a					;cp 0
	jp z, CURSOR_KEY_LOOP		;0 = no help
	push ix				;save ix |\
	push de				;save de |-> cursor positions
	ld hl, MOVES			;offset for the max moves
	dec (hl)				;a help counts as a move :)
	ld b, 0				;\
	ld c, a				;-> ld bc, a
	ld hl, LITE_BOARD-1		;1 less than the beginning to get the correct lite on
	add hl, bc				;get the offset
	ld a, 2				;blink code 2:
	push hl				;save hl
	ld (BLINK_CODE), a		;blink one lite [(hl)]
	call BLINK				;blink (hl)
	pop ix				;hl -> ix
	call CHANGE_ADJ			;change all lites adjacent to ix
	call REFRESH_LITES		;refresh the lite board to the graph mem
	ROM_CALL(DISP_GRAPH)		;copy the graph mem to the lcd
	ld a, 2				;current help = 2 now
	ld (CURRENT_HELP), a		;load the help #
	pop de				;restore de
	pop ix				;restore ix
	jp CURSOR				;go to cursor starting point

HELP_ON_2:
	ld a, (HELP2)			;get 2nd help
	or a					;0 = no help
	jp z, CURSOR_KEY_LOOP		;keep checking for keypresses
	push ix				;\
	push de				;-> cursor positions
	ld hl, MOVES			;offset for moves left
	dec (hl)				;a help is a move
	ld b, 0				;\
	ld c, a				;-> ld bc, a
	ld hl, LITE_BOARD-1		;before the lite board, for the right lite on
	add hl, bc				;get there!
	ld a, 2				;blink code = 2:
	push hl				;save hl
	ld (BLINK_CODE), a		;blink one lite [(hl)]
	call BLINK				;blink the help lite
	pop ix				;hl -> ix
	call CHANGE_ADJ			;change all lites adjacent to ix
	call REFRESH_LITES		;refresh the lite board to the graph mem
	ROM_CALL(DISP_GRAPH)		;copy the graph mem to the lcd
	xor a					;ld a, 0
	ld (DO_YOU_HELP), a		;no more helping!!!
	pop de				;restore de
	pop ix				;restore ix
	jp CURSOR				;go to the cursor starting point

;;;;;;;;;;;;;;;;;;;;;
;;;               ;;;
;;;  End of help  ;;;
;;;               ;;;
;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                             ;;;
;;;  Change all adjacent lites  ;;;
;;;                             ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CHANGE_ADJ:
	ld a, (ix)				;get byte at (ix)
	xor 1					;change it
	ld (ix), a				;and load it back

	.db $DD				;ix prefix
	ld a, l				;lower byte of ix
	cp $94				;if you're on the top row,
	jr c, CHANGE_DOWN			;don't go higher
	ld a, (ix-5)			;get byte upward of ix
	xor 1					;change it
	ld (ix-5), a			;and load it back

CHANGE_DOWN:
	.db $DD				;ix prefix
	ld a, l				;lower byte of ix
	cp $A3				;if you're on the bottom row,
	jr nc, CHANGE_RIGHT		;erase the cursor
	jr z, CHANGE_RIGHT		;dont go too far down!
	ld a, (ix+5)			;get byte downward of ix
	xor 1					;change it
	ld (ix+5), a			;and load it back

CHANGE_RIGHT:
	.db $DD				;ix prefix
	ld a, l				;lower byte of ix
	ld hl, RIGHT_LIMITS		;check the limit table
	ld bc, 5				;5 bytes to check
	cpir					;check for it!
	jr z, CHANGE_LEFT			;nope, too far right
	ld a, (ix+1)			;get byte to the right of ix
	xor 1					;change it
	ld (ix+1), a			;and load it back

CHANGE_LEFT:
	.db $DD
	ld a, l				;lower byte of ix
	ld hl, LEFT_LIMITS		;table of limits
	ld bc, 5				;5 bytes to check
	cpir					;check
	ret z					;too far left
	ld a, (ix-1)			;get byte to the left of ix
	xor 1					;change it
	ld (ix-1), a			;and load it back
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                ;;;
;;;  End of Change Adjacent Lites  ;;;
;;;                                ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                  ;;;
;;;  Have you turned the Lites Out?  ;;;
;;;                                  ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CHECK_CLEARED:
	ld hl, LITE_BOARD			;start at the beginning of the lite board
	ld b, 25				;25 bytes to check
CHECK_CLEARED_LOOP:
	ld a, (hl)				;get byte from lite board
	or a					;cp 0
	ret nz				;return if it isn't zero
	inc hl				;go to next byte in the lite board
	djnz CHECK_CLEARED_LOOP		;keep looking for nonzero bytes
	inc sp				;dont return to
	inc sp				;GAME_LOOP or GAME3_LOOP
	ld a, (STATE)			;too many moves?
	or a					;cp 0
	jp z, X				;yes, make a big "X"
	ld a, (COUNTER)			;how many moves over are you?
	or a					;cp 0
	jr z, EXACT_MOVES			;none???  WOW!  move on
	ld b, a				;load the counter
	call BUFCLEAR2			;clear the lite board
	ld hl, LITE_BOARD			;hl points to the beginning of the lite board
EXTRA_MOVES_LOOP:
	ld (hl), 1				;turn on that lite
	inc hl				;next byte in the lite board
	djnz EXTRA_MOVES_LOOP		;loop until you have the appropriate number of lites on
	ld a, 1				;1 = blink entire screen
	ld (BLINK_CODE), a		;2nd mode of blinking
	call BLINK				;blink the screen
	jr NEXT_LEVEL			;skip the next part...

EXACT_MOVES:
	call STARTUP			;watch the lites chase around the lite board
	ld a, (GAME_MODE)			;what mode are we in?
	cp 3					;mode 3?
	jp z, MODE_SELECT			;it's mode 3, so stop here

NEXT_LEVEL:
	ld hl, (CURRENT_LEVEL)		;get offset to current level
	ld bc, LEVELSIZE			;add it to the current level size
	add hl, bc				;|
	ld de, LEVEL50+LEVELSIZE	;are we past level 50?
	call CP_HL_DE			;|
	jr nz, ALL_CLEAR			;no, you're fine
	call BUFCLEAR2
	ld de, $8A3D			;middle of the screen
	ld ix, $809B			;|
	jp START				;go back to the cross in the middle

ALL_CLEAR:
	ld (CURRENT_LEVEL), hl		;load current level
	ld de, (MAX_LEVEL)		;get offset for the max level
	call CP_HL_DE			;compare the two
	jr c, RESTART			;less than
	jr z, RESTART			;equal to

	ld a, (GAME_MODE)			;get the current mode
	cp 2					;mode 2 - you dont inc the max level
	jr nz, ALL_CLEAR_TOO		;nope, it's all clear

	ld de, -LEVELSIZE			;adding negatives is like subtracting
	add hl, de				;go to previous level

ALL_CLEAR_TOO:
	ld (MAX_LEVEL), hl		;load hl into the max level
	ld (CURRENT_LEVEL), hl		;ld hl into the current level

RESTART:
	ld a, (GAME_MODE)			;get game mode
	cp 1					;mode 1
	jp z, GAME1_START			;go to the start of mode 1
	jp GAME2_START			;go to the start of mode 2

X:
	ld hl, LEVELX			;level that looks like an X
	call DECOMPRESS			;decompress it to the lite board
	ld a, 1				;blink code 1 = blink entire screen
	ld (BLINK_CODE), a		;load the code :)
	call BLINK				;blink the screen (the X)

	ld a, (GAME_MODE)			;get current game mode
	cp 1					;mode 1
	jp z, GAME1_START			;go to mode 1 start
	cp 2					;mode 2
	jp z, GAME2_START_AGAIN		;go to mode 2 start again

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                        ;;;
;;;  End of Check Cleared  ;;;
;;;                        ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                              ;;;
;;;  Miscellany Blinker routine  ;;;
;;;                              ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BLINK:
	push de				;save de
	push hl				;save hl
	ld hl, LITE_BOARD			;save lite board
	ld de, SAVE_LITE_BOARD		;|
	ld bc, 25				;|
	ldir					;|
	pop hl				;restore hl
	ld b, 3				;loop 3 times
	ld a, (BLINK_CODE)		;get the code for which type of blink
	cp 2					;2 = one lite
	jr z, BLINK2			;blink one lite
	call BLINK_DELAY			;display, display, delay, return
BLINK_LOOP:
	push bc				;save bc
	call BUFCLEAR2			;clear lite board
	call BLINK_DELAY			;display, display, delay, return
	ld de, LITE_BOARD			;restore lite board
	ld hl, SAVE_LITE_BOARD		;|
	ld bc, 25				;|
	ldir					;|
	call BLINK_DELAY			;display, display, delay, return
	pop bc				;restore bc
	djnz BLINK_LOOP			;loop
	pop de				;restore de
	ret

BLINK2:
	ld (hl), 1				;turn lite on
	call BLINK_DELAY			;display, display, delay, return
BLINK2_LOOP:
	ld (hl), 0				;turn lite off
	call BLINK_DELAY			;display, display, delay, return
	ld (hl), 1				;turn lite on
	call BLINK_DELAY			;display, display, delay, return
	djnz BLINK2_LOOP			;loop

	ld de, LITE_BOARD			;restore lite board
	ld hl, SAVE_LITE_BOARD		;|
	ld bc, 25				;|
	ldir					;|
	pop de				;restore de
	ret

BLINK_DELAY:
	push bc				;save bc
	push hl				;save hl
	call REFRESH_LITES		;refresh the lite board to the graph mem
	ROM_CALL(DISP_GRAPH)		;copy the graph mem to the lcd0
	ld b, 30				;30 loops of delay is adequate
BLINK_DELAY_LOOP:
	ld a, $FD				;mask for detection of clear
	out (1), a				;mask the keyport
	in a, (1)				;get keypresses, if any
	bit 6, a				;bit 6 = clear
	jr nz, BLINK_DONT_RET		;clear not pressed, go on
	pop hl				;restore hl
	pop bc				;restore bc
	inc sp				;don't return to
	inc sp				;BLINK
	inc sp				;don't return to
	inc sp				;HELP, CHECK_CLEARED, or BLINK_LEVEL
	inc sp				;don't return to
	inc sp				;GAME_LOOP or GAME3_LOOP
	ret					;return to shell
BLINK_DONT_RET:
	halt					;wait for int
	djnz BLINK_DELAY_LOOP		;keep looping
	pop hl				;restore hl
	pop bc				;restore bc
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                      ;;;
;;;  End of the blinker  ;;;
;;;                      ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                ;;;
;;;     Routine for putting the Game Pieces (includes cursor)      ;;;
;;;  Special Thanks to Jimmy Mrdell for the Online Zshell School  ;;;
;;;                                                                ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PUTPIECE:
	push de
	ld b, 8				;all sprites in Lites Out are (conveniently) 8x8
PP_NEW_ROW:
	push bc				;save bc
	push de				;save de
	ld a, (hl)				;get byte of sprite :)
	inc hl				;go to next byte
	ex de, hl				;exchange (hl=graph mem, de=sprite)
	xor (hl)				;Lites Out also xors all sprites
	ld (hl), a				;load it into graph mem
	inc hl				;next byte of graph mem
	pop hl				;restore de (hl now)
	ld bc, 12				;12 = next row down
	add hl, bc				;get there!
	ex de, hl				;exchange back (hl=sprite, de=graph mem)
	pop bc				;restore counters
	djnz PP_NEW_ROW			;loop
	pop de
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                   ;;;
;;;  End of PutPiece  ;;;
;;;                   ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                               ;;;
;;;  BufClear - Clears the Graph Mem or Text Mem  ;;;
;;;                                               ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BUFCLEAR:
	ld hl, $88B8			;start at graph mem
	ld de, $88B9			;graph mem + 1
	ld bc, $2FF				;graph mem is $300 bytes, first byte is already done
	ld (hl), 0				;0 = number to fill
	ldir					;copy
	ret

BUFCLEAR2:
	push bc				;bc is saved
	ld hl, LITE_BOARD			;start at the lite board
	ld de, LITE_BOARD+1		;go to lite board + 1
	ld bc, 24				;24 bytes to clear
	ld (hl), 0				;because this one is taken care of already
	ldir					;erase away :)
	pop bc				;restore bc
	ret

BUFCLEAR3:
	ld hl, ARCHIVE			;start at the move archive
	ld de, ARCHIVE+1			;go to next byte
	ld bc, 14				;14 bytes to clear
	ld (hl), 0				;cuz this one is taken care of
	ldir					;erase now
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                   ;;;
;;;  End of BufClear  ;;;
;;;                   ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;

#IFDEF SOUND

#define   P_HI      %11000000        ;code to put port high
#define   P_LO      %11111100        ;code to put port low
#define   C_PORT    %00000000        ;addres of com port

beep:					;by Eric Linenberg	
 push    af
 push    bc
 di      
set_low:
 ld      b,P_LO         
 ld      c,C_PORT      
 out     (c),b          
 push    hl
Delay16bit1:
 dec     hl
 ld      a,l
 or      h
 jr      nz,Delay16bit1
 pop     hl
set_high:
 ld      b,P_HI         
 ld      c,C_PORT       
 out     (c),b          
 push    hl
Delay16bit2:
 dec     hl
 ld      a,l
 or      h
 jr      nz,Delay16bit2
 pop     hl
 dec     de
 ld      a,d
 cp      0
 jr      nz,beep
 ei
 pop     bc
 pop     af
 ret

#ENDIF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                         ;;;
;;;  All the various texts  ;;;
;;;                         ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

AUTHOR:
	.db "by Adamman", 0				;(58,24)

RESET_TEXT:
	.db " Game reset to  "
	.db "   Level One    ", 0

#IFDEF SOUND
HEADPHONE_TEXT:
	.db "Insert headphone"
	.db "    cord NOW    "
	.db "                "
	.db "Press any key...", 0
#ENDIF

;;;;;;;;;;;;;;;;;;;;;;
;;;                ;;;
;;;  End of texts  ;;;
;;;                ;;;
;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                   ;;;
;;;  All the sprites  ;;;
;;;                   ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;

LITE_SPRITE:
	.db %01111100
	.db %11000110
	.db %10111110
	.db %10111110
	.db %10111110
	.db %11111110
	.db %01111100
	.db %00000000

L_SPRITE:
	.db %11100000
	.db %11100000
	.db %11100000
	.db %11100000
	.db %11111110
	.db %11111110
	.db %11111110
	.db %00000000

I_SPRITE:
	.db %00111000
	.db %00111000
	.db %00111000
	.db %00111000
	.db %00111000
	.db %00111000
	.db %00111000
	.db %00000000

T_SPRITE1:
	.db %11111110
	.db %11111110
	.db %11111110
	.db %00111000
	.db %00111000
	.db %00111000
	.db %00111000
	.db %00000000

E_SPRITE:
	.db %11111110
	.db %11111110
	.db %11100000
	.db %11111000
	.db %11100000
	.db %11111110
	.db %11111110
	.db %00000000

S_SPRITE:
	.db %01111100
	.db %11101110
	.db %11110000
	.db %01111100
	.db %00011110
	.db %11101110
	.db %01111100
	.db %00000000

O_SPRITE:
	.db %01111100
	.db %11111110
	.db %11111110
	.db %11000110
	.db %11000110
	.db %11111110
	.db %01111100
	.db %00000000

U_SPRITE:
	.db %01111110
	.db %11111110
	.db %11111110
	.db %11000000
	.db %11000000
	.db %11111110
	.db %01111110
	.db %00000000

T_SPRITE2:
	.db %00001110
	.db %00001110
	.db %11111110
	.db %11111110
	.db %11111110
	.db %00001110
	.db %00001110
	.db %00000000

CURSOR_PIECE:
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111

;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                     ;;;
;;;  All of the levels  ;;;
;;;                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAX_LEVEL:
	.dw LEVEL1

CURRENT_LEVEL:
	.dw LEVEL1

#include levels.inc

;;;;;;;;;;;;;;;;;;;;;;;
;;;                 ;;;
;;;  End of levels  ;;;
;;;                 ;;;
;;;;;;;;;;;;;;;;;;;;;;;

.end
